
#define J_ID_RWHEEL 3
#define J_ID_LWHEEL 4
#define J_ID_RARM   2
#define J_ID_LARM   1
#define J_ID_HEAD   5
#define SONAR_PIN   0

const char EOPmarker = '.'; //This is the end of packet marker
char serialbuf[64]; //This gives the incoming serial some room. Change it if you want a longer incoming.

#include <string.h> // we'll need this for subString
#define MAX_STRING_LEN 20 // like 3 lines above, change as needed.

Dynamixel Dxl(1);
 
void setup() {
 Dxl.begin(3);  
 setDefaultDxlConfig();
 Serial2.begin(9600);
 SerialUSB.begin();
 SerialUSB.println("Inited");
 pinMode(SONAR_PIN, INPUT_ANALOG);
}

void loop() {

    if (Serial2.available() > 0) { //makes sure something is ready to be read
      static int bufpos = 0; //starts the buffer back at the first position in the incoming serial.read
      char inchar = Serial2.read(); //assigns one byte (as serial.read()'s only input one byte at a time
      if (inchar != EOPmarker) { //if the incoming character is not the byte that is the incoming package ender
        serialbuf[bufpos] = inchar; //the buffer position in the array get assigned to the current read
        bufpos++; //once that has happend the buffer advances, doing this over and over again until the end of package marker is read.
      }
      else { //once the end of package marker has been read
        serialbuf[bufpos] = 0; //restart the buff
        bufpos = 0; //restart the position of the buff
        int command = atoi(subStr(serialbuf, ",", 1));
        SerialUSB.print("Received Command ");
        SerialUSB.println(serialbuf);
        process_command(command, serialbuf);
        //SerialUSB.print("The command is: ");
        //SerialUSB.println(command); 
      }
    }
}

char* subStr (char* input_string, char *separator, int segment_number) {
  char *act, *sub, *ptr;
  static char copy[MAX_STRING_LEN];
  int i; 
  strcpy(copy, input_string);
  for (i = 1, act = copy; i <= segment_number; i++, act = NULL) {
    sub = strtok_r(act, separator, &ptr);
    if (sub == NULL) break;
  }
 return sub;
}


void  setDefaultDxlConfig()
{
  // RIGHT WHEEL
  Dxl.wheelMode(J_ID_RWHEEL);   
  Dxl.maxTorque(J_ID_RWHEEL,1023);
  Dxl.goalTorque(J_ID_RWHEEL, 1023);
  Dxl.goalSpeed(J_ID_RWHEEL, 0);
  
 // LEFT WHEEL
  Dxl.wheelMode(J_ID_LWHEEL); 
  Dxl.maxTorque(J_ID_LWHEEL,1023);
  Dxl.goalTorque(J_ID_LWHEEL, 1023);
  Dxl.goalSpeed(J_ID_LWHEEL, 0);
  
  // RIGHT ARM
  Dxl.jointMode(J_ID_RARM); 
  Dxl.maxTorque(J_ID_RARM,1023);
  Dxl.goalTorque(J_ID_RARM, 1023);
  Dxl.goalSpeed(J_ID_RARM,   40);
  
 // LEFT ARM
  Dxl.jointMode(J_ID_LARM); 
  Dxl.maxTorque(J_ID_LARM,1023);
  Dxl.goalTorque(J_ID_LARM, 1023);
  Dxl.goalSpeed(J_ID_LARM,   40); 
  
  // HEAD
  Dxl.jointMode(J_ID_HEAD); 
  Dxl.maxTorque(J_ID_HEAD,1023);
  Dxl.goalTorque(J_ID_HEAD, 1023);
  Dxl.goalSpeed(J_ID_HEAD, 30);
  
  SET_HEAD_POSITION("9,75");
  SET_LEFT_ARM_POSITION("3,30");
  SET_RIGHT_ARM_POSITION("31,30");
}

void process_command(int command_code, char *args)
{
   switch (command_code)
   {
      //
      case 1:
         SerialUSB.println("Exec command SET_LEFT_WHEEL_SPEED");
         SET_LEFT_WHEEL_SPEED (args);
      break;
      case 111:
         SerialUSB.println("Exec command SET_RIGHT_WHEEL_SPEED");
         SET_RIGHT_WHEEL_SPEED (args);
      break;      
      case 2:
          SerialUSB.println("Exec command GET_WHEEL_SPEED");
          // int GET_WHEEL_SPEED (WHEEL_ID)
      break;
      case 3:
          SerialUSB.println("Exec command SET_LEFT_ARM_POSITION");
          SET_LEFT_ARM_POSITION (args);
      break;  
      /*
      case 4:
          SerialUSB.println("Exec command GET_LEFT_ARM_POSITION");
          // int GET_LEFT_ARM_POSITION ()
      break;     
      case 5:
          SerialUSB.println("Exec command SET_LEFT_ARM_SPEED");
          // void SET_LEFT_ARM_SPEED (SPEED)
      break;        
      case 6:
          SerialUSB.println("Exec command GET_ARM_SPEED");
          // int GET_LEFT_ARM_SPEED ()
      break;          
    */
  
       case 31:
          SerialUSB.println("Exec command SET_RIGHT_ARM_POSITION");
          SET_RIGHT_ARM_POSITION (args);
      break;  
      /*
      case 41:
          SerialUSB.println("Exec command GET_RIGHT_ARM_POSITION");
          // int GET_RIGHT_ARM_POSITION ()
      break;     
      case 51:
          SerialUSB.println("Exec command SET_RIGHT_ARM_SPEED");
          // void SET_RIGHT_ARM_SPEED (SPEED)
      break;        
      case 61:
          SerialUSB.println("Exec command GET_RIGHT_ARM_SPEED");
          // int GET_RIGHT_ARM_SPEED ()
      break;          
 
      
      case 8:
          SerialUSB.println("Exec command GET_HEAD_POSITION");
          //int GET_HEAD_POSITION ()
      break;    
      */
      case 9:
          SerialUSB.println("Exec command SET_HEAD_POSITION");
          SET_HEAD_POSITION (args);
      break;  
      /*
      case 10:
          Serial2.println("Exec command SET_HEAD_SPEED");
          // int SET_HEAD_SPEED (SPEED)
      break;      
      case 11:
          SerialUSB.println("Exec command GET_HEAD_SPEED");
          // int GET_HEAD_SPEED (SPEED)
      break;  
      case 12:
          SerialUSB.println("Exec command IS_HEAD_MOVING");
           // int IS_HEAD_MOVING ()
      break; 
      case 13:
          SerialUSB.println("Exec command IS_ARM_MOVING");
           // int IS_ARM_MOVING (ARM_ID)
      break;       
     
      */      
      case 14:
          SerialUSB.println("Exec command READ_SONAR");
          READ_SONAR (args);
      break;        
      default:
         SerialUSB.println("Unknown command");
      break; 
   }
}

void READ_SONAR(char * args)
{
  int AdcData = analogRead(0);
  Serial2.println(AdcData);
}

void SET_HEAD_POSITION(char * args)
{
   // HEAD CAN MOVE FROM 750 to 900 , center is 825
   // INPUT FROM 0 = All-Right , 150 = All-Left, 75 = Center
   int offset = 750;
   int position = atoi(subStr(args, ",", 2));
   SerialUSB.print("Param position = "); SerialUSB.println(position);
   if (position >= 0 && position <= 150)
   {
      Dxl.goalPosition(J_ID_HEAD, offset+position);
      SerialUSB.println(" Done.");
   }
   else
   {
     SerialUSB.println(" Invalid Param.");
   }
}

void SET_LEFT_WHEEL_SPEED(char * args)
{
    int speed = atoi(subStr(args, ",", 2));
    SerialUSB.print("Param speed = "); SerialUSB.println(speed);
    if (speed >= -800 && speed <= 800)
    {    
      if (speed < 0) speed = abs(speed) + 1024;
      Dxl.goalSpeed(J_ID_LWHEEL, speed); 
      SerialUSB.println(" Done.");
    }
   else
   {
     SerialUSB.println(" Invalid Param.");
   }       
}

void SET_RIGHT_WHEEL_SPEED(char * args)
{
    int speed = atoi(subStr(args, ",", 2));
    SerialUSB.print("Param speed = "); SerialUSB.println(speed);
    if (speed >= -800 && speed <= 800)
    {    
      if (speed > 0) speed = speed + 1024;
      else 
        speed = abs(speed);
      Dxl.goalSpeed(J_ID_RWHEEL, speed); 
      SerialUSB.println(" Done.");
    }
   else
   {
     SerialUSB.println(" Invalid Param.");
   }       
}

void SET_LEFT_ARM_POSITION(char * args)
{
    // LEFT ARM CAN SWING FROM 550 (bottom) to 730 (up)
    // INPUT FROM 0 = All bottom , 90 = All-Up, 45 = Center
    int position = atoi(subStr(args, ",", 2));
    SerialUSB.print("Param position = "); SerialUSB.println(position);
    if (position >= 0 && position <= 90)
    {    
      Dxl.goalPosition(J_ID_LARM, 550 + (position*2)); 
      SerialUSB.println(" Done.");
    }
   else
   {
     SerialUSB.println(" Invalid Param.");
   }    
}

void SET_RIGHT_ARM_POSITION(char * args)
{
    // RIGHT ARM CAN SWING FROM 590 (bottom) to 430 (up)
    // INPUT FROM 0 = All bottom , 90 = All-Up, 45 = Center
    int position = atoi(subStr(args, ",", 2));
    SerialUSB.print("Param position = "); SerialUSB.println(position);
    if (position >= 0 && position <= 90)
    {    
      Dxl.goalPosition(J_ID_RARM, 590 - (position*2)); 
      SerialUSB.println(" Done.");
    }
   else
   {
     SerialUSB.println(" Invalid Param.");
   }    
}
